diff --git a/xen/xsm/flask/policy/mkaccess_vector.sh b/xen/xsm/flask/policy/mkaccess_vector.sh
index 7fa4aaf638..942ede4713 100755
--- a/xen/xsm/flask/policy/mkaccess_vector.sh
+++ b/xen/xsm/flask/policy/mkaccess_vector.sh
@@ -22,7 +22,7 @@ BEGIN	{
 		printf("/* This file is automatically generated.  Do not edit. */\n") > avpermfile;
 ;
 	}
-/^[ \t]*#/	{ 
+/^[ \t]*#/	{
 			next;
 		}
 $1 == "class"	{
@@ -30,7 +30,7 @@ $1 == "class"	{
 			    nextstate != "CLASS_OR_CLASS-OPENBRACKET")
 			{
 				printf("Parse error:  Unexpected class definition on line %d\n", NR);
-				next;	
+				next;
 			}
 
 			tclass = $2;
@@ -39,7 +39,7 @@ $1 == "class"	{
 			{
 				printf("Duplicate access vector definition for %s on line %d\n", tclass, NR);
 				next;
-			} 
+			}
 			av_defined[tclass] = 1;
 
 			permission = 0;
@@ -47,7 +47,7 @@ $1 == "class"	{
 			nextstate = "INHERITS_OR_CLASS-OPENBRACKET";
 			next;
 		}
-$1 == "{"	{ 
+$1 == "{"	{
 			if (nextstate != "INHERITS_OR_CLASS-OPENBRACKET" &&
 			    nextstate != "CLASS_OR_CLASS-OPENBRACKET" &&
 			    nextstate != "COMMON-OPENBRACKET")
@@ -69,7 +69,7 @@ $1 == "{"	{
 			if (nextstate != "COMMON-CLOSEBRACKET" &&
 			    nextstate != "CLASS-CLOSEBRACKET")
 			{
-				printf("Parse error:  Unexpected symbol %s on line %d\n", $1, NR);		
+				printf("Parse error:  Unexpected symbol %s on line %d\n", $1, NR);
 				next;
 			}
 
@@ -83,7 +83,7 @@ $1 == "{"	{
 
 				common_perms[common_name,$1] = permission;
 
-				printf("#define COMMON_%s__%s", toupper(common_name), toupper($1)) > outfile; 
+				printf("#define COMMON_%s__%s", toupper(common_name), toupper($1)) > outfile;
 
 				printf("    S_(\"%s\")\n", $1) > cpermfile;
 			}
@@ -96,23 +96,23 @@ $1 == "{"	{
 				}
 
 				av_perms[tclass,$1] = permission;
-		
-				printf("#define %s__%s", toupper(tclass), toupper($1)) > outfile; 
 
-				printf("   S_(SECCLASS_%s, %s__%s, \"%s\")\n", toupper(tclass), toupper(tclass), toupper($1), $1) > avpermfile; 
+				printf("#define %s__%s", toupper(tclass), toupper($1)) > outfile;
+
+				printf("   S_(SECCLASS_%s, %s__%s, \"%s\")\n", toupper(tclass), toupper(tclass), toupper($1), $1) > avpermfile;
 			}
 
 			spaces = 40 - (length($1) + length(tclass));
 			if (spaces < 1)
 			      spaces = 1;
 
-			for (i = 0; i < spaces; i++) 
-				printf(" ") > outfile; 
+			for (i = 0; i < spaces; i++)
+				printf(" ") > outfile;
 			printf("(1UL << %u)\n", permission) > outfile;
 			permission = permission + 1;
 		}
 $1 == "}"	{
-			if (nextstate != "CLASS-CLOSEBRACKET" && 
+			if (nextstate != "CLASS-CLOSEBRACKET" &&
 			    nextstate != "COMMON-CLOSEBRACKET")
 			{
 				printf("Parse error:  Unexpected } on line %d\n", NR);
@@ -122,7 +122,7 @@ $1 == "}"	{
 			if (nextstate == "COMMON-CLOSEBRACKET")
 			{
 				common_base[common_name] = permission;
-				printf("TE_(common_%s_perm_to_string)\n\n", common_name) > cpermfile; 
+				printf("TE_(common_%s_perm_to_string)\n\n", common_name) > cpermfile;
 			}
 
 			printf("\n") > outfile;
diff --git a/xen/xsm/flask/policy/mkflask.sh b/xen/xsm/flask/policy/mkflask.sh
index 989a323b80..591ce832a1 100755
--- a/xen/xsm/flask/policy/mkflask.sh
+++ b/xen/xsm/flask/policy/mkflask.sh
@@ -37,51 +37,51 @@ BEGIN	{
 		printf("static char *initial_sid_to_string[] =\n{\n") > debugfile2;
 		printf("    \"null\",\n") > debugfile2;
 	}
-/^[ \t]*#/	{ 
+/^[ \t]*#/	{
 			next;
 		}
-$1 == "class"	{ 
+$1 == "class"	{
 			if (nextstate != "CLASS")
 			{
 				printf("Parse error:  Unexpected class definition on line %d\n", NR);
-				next;	
+				next;
 			}
 
 			if ($2 in class_found)
 			{
 				printf("Duplicate class definition for %s on line %d.\n", $2, NR);
 				next;
-			}	
+			}
 			class_found[$2] = 1;
 
 			class_value++;
 
 			printf("#define SECCLASS_%s", toupper($2)) > outfile;
-			for (i = 0; i < 40 - length($2); i++) 
-				printf(" ") > outfile; 
-			printf("%d\n", class_value) > outfile; 
+			for (i = 0; i < 40 - length($2); i++)
+				printf(" ") > outfile;
+			printf("%d\n", class_value) > outfile;
 
 			printf("    S_(\"%s\")\n", $2) > debugfile;
 		}
-$1 == "sid"	{ 
+$1 == "sid"	{
 			if (nextstate == "CLASS")
 			{
 			    nextstate = "SID";
-			    printf("\n/*\n * Security identifier indices for initial entities\n */\n") > outfile;			    
+			    printf("\n/*\n * Security identifier indices for initial entities\n */\n") > outfile;
 			}
 
 			if ($2 in sid_found)
 			{
 				printf("Duplicate SID definition for %s on line %d.\n", $2, NR);
 				next;
-			}	
+			}
 			sid_found[$2] = 1;
 			sid_value++;
 
 			printf("#define SECINITSID_%s", toupper($2)) > outfile;
-			for (i = 0; i < 37 - length($2); i++) 
-				printf(" ") > outfile; 
-			printf("%d\n", sid_value) > outfile; 
+			for (i = 0; i < 37 - length($2); i++)
+				printf(" ") > outfile;
+			printf("%d\n", sid_value) > outfile;
 			printf("    \"%s\",\n", $2) > debugfile2;
 		}
 END	{
@@ -89,9 +89,9 @@ END	{
 			printf("Parse error:  Unexpected end of file\n");
 
 		printf("\n#define SECINITSID_NUM") > outfile;
-		for (i = 0; i < 34; i++) 
-			printf(" ") > outfile; 
-		printf("%d\n", sid_value) > outfile; 
+		for (i = 0; i < 34; i++)
+			printf(" ") > outfile;
+		printf("%d\n", sid_value) > outfile;
 		printf("\n#endif /* __XEN__ || __XEN_TOOLS__ */\n") > outfile;
 		printf("\n#endif\n") > outfile;
 		printf("};\n\n") > debugfile2;